//+------------------------------------------------------------------+
//|                                             e-Grabber-Murrey.mq4 |
//|                                             v.06                 |
//|      10.16.2006    Copyright  2006,     |
//+------------------------------------------------------------------+
/*
      .     
    . 
 .         . 
 Murrey_Math_MT_VG_even.        
.         "mml0", "mml2", 
"mml4", "mml6", "mml8" "mml10" "mml12"   ,   
              
  . :     , 
    .

  "ebBuyFromUp"  BUY   . 
      "ebBuyFromUp"  "FALSE", 
   SELL   .
  "ebSellFromDn"  SELL   . 
      "ebSellFromDn"  "FALSE", 
   BUY   . 

   .  "ebBuyStoch"  "TRUE"  
BUY     ,     
 .  SELL -     .
 "ebBuyStoch"  "FALSE"  BUY    , 
     .

*/
#property copyright "Copyright  2006, lukas1"
#property link      "www.alpari-idc.ru"
//
extern double Lots         = 0.1;      //   
extern int    StopLoss     = 33;       //   
extern int    TakeProfit   = 50;       //   
extern int    Slippage     = 3;        //  
//
extern bool   ebBuyFromUp   = FALSE;   //    
extern bool   ebSellFromDn  = FALSE;   //    
extern bool   ebShowComment = TRUE;    //  
extern bool   ebAdaptiveStop= FALSE;   //  TP,SL   
//
extern int    Stoch_p1    = 15;        //   %
extern int    Stoch_p2    = 18;        //   %
extern int    Stoch_t1    = 12;        //  
extern bool   ebBuyStoch  = TRUE;      //   
//
extern string line1_name = "mml0";
extern string line2_name = "mml2";
extern string line3_name = "mml4";
extern string line4_name = "mml6";
extern string line5_name = "mml8";
extern string line6_name = "mml10";
extern string line7_name = "mml12";
//
string esNameUpLine;//   
string esNameDnLine;//   
//-------    --
string Name_Expert   = "e-Grabber-Murrey";
bool   UseSound      = True;           //   
string NameFileSound = "expert.wav";   //   
color  clOpenBuy     = LightBlue;      //    
color  clOpenSell    = LightCoral;     //    
color  clCloseBuy    = Blue;           //    
color  clCloseSell   = Red;            //    
double gdUpPrice, gdDnPrice;           //   
double gdPrevUpPrice, gdPrevDnPrice;   //   
double gdPrevAsk, gdPrevBid;           //  
double gdPrev2Ask, gdPrev2Bid;           //  
int    obj_total;
double line1_price,line2_price,line3_price,line4_price,line5_price;
double line6_price,line7_price,line8_price,line9_price,line10_price;
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
void deinit() { if (!IsTesting()) Comment(""); }

//+------------------------------------------------------------------+
//| expert program start function                                    |
//+------------------------------------------------------------------+
void start() 
  {
  obj_total=ObjectsTotal(OBJ_HLINE);   // -    
  line1_price = ObjectGet(line1_name,OBJPROP_PRICE1);
  line2_price = ObjectGet(line2_name,OBJPROP_PRICE1);  
  line3_price = ObjectGet(line3_name,OBJPROP_PRICE1);  
  line4_price = ObjectGet(line4_name,OBJPROP_PRICE1);  
  line5_price = ObjectGet(line5_name,OBJPROP_PRICE1);  
  line6_price = ObjectGet(line6_name,OBJPROP_PRICE1);  
  line7_price = ObjectGet(line7_name,OBJPROP_PRICE1);  
     //  gdUpPrice  
     //      
  gdUpPrice=line2_price; esNameUpLine="mml2";
  if (line2_price<Ask) {gdUpPrice=line3_price; esNameUpLine="mml4";}
  if (line3_price<Ask) {gdUpPrice=line4_price; esNameUpLine="mml6";}
  if (line4_price<Ask) {gdUpPrice=line5_price; esNameUpLine="mml8";}
  if (line5_price<Ask) {gdUpPrice=line6_price; esNameUpLine="mml10";}
  if (line6_price<Ask) {gdUpPrice=line7_price; esNameUpLine="mml12";}
     //  gdDnPrice  
     //      
  gdDnPrice=line6_price; esNameDnLine="mml10";//   
  if (line6_price>Bid) {gdDnPrice=line5_price; esNameDnLine="mml8";}
  if (line5_price>Bid) {gdDnPrice=line4_price; esNameDnLine="mml6";}
  if (line4_price>Bid) {gdDnPrice=line3_price; esNameDnLine="mml4";}
  if (line3_price>Bid) {gdDnPrice=line2_price; esNameDnLine="mml2";}
  if (line2_price>Bid) {gdDnPrice=line1_price; esNameDnLine="mml0";}
       
  //if (idRightCondition() && gdPrevAsk!=0 && gdPrevBid!=0) // gdPrevAsk  gdPrevBid
  if (idRightCondition()) // gdPrevAsk  gdPrevBid  
       OpenPositions();
  if (ebShowComment) 
      {
    string st="";
    if (gdUpPrice==0) st="    \n";
    /*else {
      if (ebBuyFromUp) st="  ";
      else st="  ";
      st=st+DoubleToStr(gdUpPrice, Digits)+"\n";
         }*/
    if (gdDnPrice==0) st=st+"    ";
    /*else {
      if (ebSellFromDn) st=st+"  ";
      else st=st+"  ";
      st=st+DoubleToStr(gdDnPrice, Digits);
         }*/
    Comment(st);
    //Comment(st);
      }
  if (gdUpPrice>0) gdPrevUpPrice=gdUpPrice;
  if (gdDnPrice>0) gdPrevDnPrice=gdDnPrice;
  //gdPrevAsk=Ask;
  //gdPrevBid=Bid;
  }
//+------------------------------------------------------------------+
//|                             |
//+------------------------------------------------------------------+
bool idRightCondition() {         //    
  double cur;                     //      UP 
  //  
  //   

  if (ObjectFind(esNameUpLine)<0) //        
      {
    gdUpPrice=0;
    gdPrevUpPrice=0;
    Message("   "+esNameUpLine);
      } else 
      {
       gdUpPrice=ObjectGet(esNameUpLine, OBJPROP_PRICE1); 
      }
  //   
  if (ObjectFind(esNameDnLine)<0) //         
      {
    gdDnPrice=0;
    gdPrevDnPrice=0;
    Message("   "+esNameDnLine);
      } else 
      {
       gdDnPrice=ObjectGet(esNameDnLine, OBJPROP_PRICE1);
      }
  /*
  if (gdUpPrice<gdPrevBid && gdUpPrice>0) {
    gdUpPrice=0;
    Message("  "+esNameUpLine+"   ");
  }
  if (gdDnPrice>gdPrevAsk && gdPrevAsk>0) {
    gdDnPrice=0;
    Message("  "+esNameDnLine+"   ");
  }
  */
  if (gdUpPrice!=gdPrevUpPrice || gdDnPrice!=gdPrevDnPrice
   || gdPrevUpPrice==0 || gdPrevDnPrice==0
   || gdUpPrice==0 || gdUpPrice==0) return(False);
  else return(True);
}
  
//+------------------------------------------------------------------+
//|                                                   |
//+------------------------------------------------------------------+
void OpenPositions() {
  bool   lbBuy=False, lbSell=False;
  double ldStop=0, ldTake=0;
   
  /*if ((Ask>gdPrevAsk && Ask>=gdUpPrice && ebBuyFromUp)
   || (Bid<gdPrevBid && Bid<=gdDnPrice && !ebSellFromDn)) lbBuy=True;
  if ((Bid>gdPrevBid && Bid>=gdUpPrice && !ebBuyFromUp)
   || (Ask<gdPrevAsk && Ask<=gdDnPrice && ebSellFromDn))  lbSell=True;   */

  if ((iClose(Symbol(),0,4) < gdDnPrice && iClose(Symbol(),0,3) < gdDnPrice && 
       iClose(Symbol(),0,2) > gdDnPrice && iClose(Symbol(),0,1) > gdDnPrice && 
       iStochastic(Symbol(),0,Stoch_p1,Stoch_p2,Stoch_t1,0,0,ebBuyStoch,0)  >
       iStochastic(Symbol(),0,Stoch_p1,Stoch_p2,Stoch_t1,0,0,!ebBuyStoch,0) &&
       ebBuyFromUp)
   || (iClose(Symbol(),0,4) > gdUpPrice && iClose(Symbol(),0,3) > gdUpPrice && 
       iClose(Symbol(),0,2) < gdUpPrice && iClose(Symbol(),0,1) < gdUpPrice && 
       iStochastic(Symbol(),0,Stoch_p1,Stoch_p2,Stoch_t1,0,0,ebBuyStoch,0)  <
       iStochastic(Symbol(),0,Stoch_p1,Stoch_p2,Stoch_t1,0,0,!ebBuyStoch,0) &&       
       !ebSellFromDn)) lbBuy=True;

  if ((iClose(Symbol(),0,4) > gdUpPrice && iClose(Symbol(),0,3) > gdUpPrice &&
       iClose(Symbol(),0,2) < gdUpPrice && iClose(Symbol(),0,1) < gdUpPrice && 
       iStochastic(Symbol(),0,Stoch_p1,Stoch_p2,Stoch_t1,0,0,ebBuyStoch,0)  <
       iStochastic(Symbol(),0,Stoch_p1,Stoch_p2,Stoch_t1,0,0,!ebBuyStoch,0) &&   
       ebSellFromDn)
   || (iClose(Symbol(),0,4) < gdDnPrice && iClose(Symbol(),0,3) < gdDnPrice && 
       iClose(Symbol(),0,2) > gdDnPrice && iClose(Symbol(),0,1) > gdDnPrice && 
       iStochastic(Symbol(),0,Stoch_p1,Stoch_p2,Stoch_t1,0,0,ebBuyStoch,0)  >
       iStochastic(Symbol(),0,Stoch_p1,Stoch_p2,Stoch_t1,0,0,!ebBuyStoch,0) &&
       !ebBuyFromUp))  lbSell=True;   
   
  if (lbBuy) {
    if (ExistPositionByOP(OP_SELL)) CloseAllPositions();
    if (!ExistPositionByOP(OP_BUY)) {
      if (StopLoss!=0) ldStop=Ask-StopLoss*Point;
      if (TakeProfit!=0) ldTake=Ask+TakeProfit*Point;
      OpenPosition(OP_BUY, ldStop, ldTake);
    }
  }
  if (lbSell) {
    if (ExistPositionByOP(OP_BUY)) CloseAllPositions();
    if (!ExistPositionByOP(OP_SELL)) {
      if (StopLoss!=0) ldStop=Bid+StopLoss*Point;
      if (TakeProfit!=0) ldTake=Bid-TakeProfit*Point;
      OpenPosition(OP_SELL, ldStop, ldTake);
    }
  }
}
//+------------------------------------------------------------------+
//|                      |
//+------------------------------------------------------------------+
bool ExistPositionByOP(int op) {
  for (int i=0; i<OrdersTotal(); i++) {
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
      if (OrderSymbol()==Symbol() && OrderType()==op) 
          return(True);
                                                    }
                                      }
                                return(False);
                               }
//+------------------------------------------------------------------+
//|                                      |
//| :       op     -                                |
//|                  ldStop -                             |
//|                  ldTake -                             |
//+------------------------------------------------------------------+
void OpenPosition(int op, double ldStop, double ldTake) 
 {
  color  clOpen;
  double pp;
  string lsComm=GetCommentForOrder();
  if (op==OP_BUY) 
      {
       clOpen=clOpenBuy;
       pp=Ask;
      } else {
              clOpen=clOpenSell;
              pp=Bid;
             }
  if (ebAdaptiveStop)
      {
  if (op==OP_BUY) 
      {
       ldTake=gdUpPrice;
       ldStop=gdDnPrice;
      } else {
              ldTake=gdDnPrice;
              ldStop=gdUpPrice;
             }
       }
  OrderSend(Symbol(),op,Lots,pp,Slippage,ldStop,ldTake,lsComm,0,0,clOpen);
  if (UseSound) PlaySound(NameFileSound);
 }
//+------------------------------------------------------------------+
//|          |
//+------------------------------------------------------------------+
string GetCommentForOrder() {
  return(Name_Expert+" "+GetNameTF(Period()));
                            }
//+------------------------------------------------------------------+
//|                                  |
//+------------------------------------------------------------------+
string GetNameTF(int TimeFrame) {
	switch (TimeFrame)            {
		case PERIOD_M1:  return("M1");
		case PERIOD_M5:  return("M5");
		case PERIOD_M15: return("M15");
		case PERIOD_M30: return("M30");
		case PERIOD_H1:  return("H1");
		case PERIOD_H4:  return("H4");
		case PERIOD_D1:  return("Daily");
		case PERIOD_W1:  return("Weekly");
		case PERIOD_MN1: return("Monthly");
		default:		     return("UnknownPeriod");
	                              }
                                }
//+------------------------------------------------------------------+
//|                                 |
//+------------------------------------------------------------------+
void CloseAllPositions()                          {
  for (int i=OrdersTotal()-1; i>=0; i--)           {
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
      if (OrderSymbol()==Symbol())                   {
        if (OrderType()==OP_BUY)                      {
          OrderClose(OrderTicket(), OrderLots(), Bid, Slippage, clCloseBuy);
                                                      }
        if (OrderType()==OP_SELL)                     {
          OrderClose(OrderTicket(), OrderLots(), Ask, Slippage, clCloseSell);
                                                      }
                                                     }
                                                    }
                                                   }
                                                  }
//+------------------------------------------------------------------+
//|                                    |
//+------------------------------------------------------------------+
void Message(string m) {
  Comment(m);
  if (StringLen(m)>0) Print(m);
}
//+------------------------------------------------------------------+

